// imagelib.h

typedef char		BYTE;
typedef unsigned char	UBYTE;
typedef short			WORD;
typedef unsigned short	UWORD;
typedef long			LONG;
typedef unsigned long	ULONG;

typedef enum
{
	ms_none,
	ms_mask,
	ms_transcolor,
	ms_lasso
} mask_t;

typedef enum
{
	cm_none,
	cm_rle1
} compress_t;

#pragma pack(1)

typedef struct
{
	UWORD		w,h;
	short		x,y;
	UBYTE		nPlanes;
	UBYTE		masking;
	UBYTE		compression;
	UBYTE		pad1;
	UWORD		transparentColor;
	UBYTE		xAspect,yAspect;
	short		pageWidth,pageHeight;
} bmhd_t;

typedef struct
{
	BYTE	manufacturer;
	BYTE	version;
	BYTE	encoding;
	BYTE	bits_per_pixel;
	UWORD	xmin,ymin,xmax,ymax;
	UWORD	hres,vres;
	UBYTE	palette[48];
	BYTE	reserved;
	BYTE	color_planes;
	UWORD	bytes_per_line;
	UWORD	palette_type;
	BYTE	filler[58];
	UBYTE	data;           // unbounded
} pcx_t;

typedef struct
{ 
	WORD	bfType;
	LONG	bfSize; 
	WORD	bfReserved1; 
	WORD	bfReserved2; 
	LONG	bfOffBits; 
} BITMAPFILEHEADER; 
 
typedef struct
{
	LONG	biSize; 
	LONG	biWidth; 
	LONG	biHeight; 
	WORD	biPlanes; 
	WORD	biBitCount;
	LONG	biCompression; 
	LONG	biSizeImage; 
	LONG	biXPelsPerMeter; 
	LONG	biYPelsPerMeter; 
	LONG	biClrUsed; 
	LONG	biClrImportant; 
} BITMAPINFOHEADER; 
 
typedef struct
{ 
	BITMAPINFOHEADER	bmiHeader; 
	UBYTE			bmiColors[1024]; 
} BITMAPINFO; 

typedef struct
{ 
	LONG	bcSize; 
	WORD	bcWidth; 
	WORD	bcHeight; 
	WORD	bcPlanes; 
	WORD	bcBitCount; 
} BITMAPCOREHEADER; 
 
typedef struct
{ 
	BITMAPCOREHEADER	bmciHeader; 
	UBYTE			bmciColors[768]; 
} BITMAPCOREINFO; 
 
#pragma pack()


void LoadImage (char *filename, byte **picture, int *width, int *height, byte **palette);

void WriteImage (char *filename, byte *data, int width, int height
	, byte *palette);

